Imports System
Imports System.Data
Imports System.ComponentModel
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Xml.Serialization
Imports System.Security
Imports System.Security.Permissions
Imports Microsoft.SharePoint
Imports Microsoft.SharePoint.Utilities
Imports Microsoft.SharePoint.WebControls
Imports Microsoft.SharePoint.WebPartPages
Imports Microsoft.SharePoint.WebPartPages.Communication
Imports VitalFactorsPortal.WebParts.VitalFactorsPortalWS

'Description for VitalFactors.
<DefaultProperty("Text"), ToolboxData("<{0}:VitalFactors runat=server></{0}:VitalFactors>"), XmlRoot(Namespace:="VitalFactorsPortal.WebParts")> _
Public Class VitalFactors
    Inherits Microsoft.SharePoint.WebPartPages.WebPart

    Protected ctlUI As VitalFactorsUI
    Protected lblMessage As New Label
    Protected lblValidUser As New Label
    Protected lblBranchList As New Label

    Private currentSite As SPSite
    Private currentWeb As SPWeb

    'config for ascx path
    Private _userControlPath As String = "/VitalFactorsPortalWP/VitalFactorsUI.ascx"

    <Browsable(True), Category("Configuration"), _
       DefaultValue("/VitalFactorsPortalWP/VitalFactorsUI.ascx"), _
       WebPartStorage(Storage.Shared), _
       FriendlyName("URL of User Control"), _
       Description("Configurable path to ascx file that provides UI for this web part")> _
       Public Property UserControlPath() As String
        Get
            Return _userControlPath
        End Get
        Set(ByVal Value As String)
            _userControlPath = Value
        End Set
    End Property

    Private ReadOnly Property CurrentUser() As SPUser
        Get
            If currentWeb Is Nothing Or currentSite Is Nothing Then
                currentSite = SPControl.GetContextSite(Context)
                currentWeb = SPControl.GetContextWeb(Context)
            End If
            Return currentWeb.CurrentUser
        End Get
    End Property

    'config for web service URL
    Private _wsURL As String

    <Browsable(True), Category("Configuration"), _
    DefaultValue(""), _
    WebPartStorage(Storage.Shared), _
    FriendlyName("URL of Web Service"), _
    Description("Configurable URL for the Web Service that provides data for this web part")> _
    Public Property WS_URL() As String
        Get
            Return _wsURL
        End Get
        Set(ByVal Value As String)
            _wsURL = Value
        End Set
    End Property

    Public Sub LoadUIControls(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Init
        'Me.ctlUI = Me.Page.LoadControl(_userControlPath)
        'Me.Controls.Add(Me.ctlUI)
    End Sub

    Protected Overrides Sub CreateChildControls()
        'Dim iX As Integer, iTop As Integer, iRecCt As Integer
        Try
            lblValidUser = New Label

            Dim ws As New VitalFactorsPortalWS.VitalFactorsPortalWS
            ws.Url = _wsURL
            Dim bTemp As Boolean
            bTemp = ws.IsUserAlowedIn(Me.CurrentUser.LoginName)
            Me.Controls.Add(Me.lblValidUser)
            If bTemp = True Then
                lblValidUser.Text = "Yes"
                Me.ctlUI = Me.Page.LoadControl(_userControlPath)
                Me.Controls.Add(Me.ctlUI)
            Else
                lblValidUser.Text = "No"
            End If
        Catch argEx As System.ArgumentNullException
            lblMessage.Text = "This web part requires a URL to the VitalFactors Portal web service. Please select Modify Shared Web Part to enter the correct URL."
            Me.Controls.Add(lblMessage)
        Catch ex As Exception
            lblMessage.Text = ex.Message
            Me.Controls.Add(lblMessage)
        End Try

    End Sub

    'Render this Web Part to the output parameter specified.
    Protected Overrides Sub RenderWebPart(ByVal output As System.Web.UI.HtmlTextWriter)
        If lblMessage.Text = "" Then
            EnsureChildControls()
            If lblValidUser.Text = "No" Then
                output.Write("<span style='font-family:Arial;font-size:18pt;'>Sorry...</span>")
                output.Write("<p>you are not authorized to view the infomation on this page.</p>")
            Else
            output.Write(String.Format("<span style='font-family:Arial;font-size:18pt;'>Welcome {0} </span>", Me.CurrentUser.Name))
            'output.Write(String.Format("<span style='font-family:Arial;font-size:18pt;'>Welcome {0} - Division {1}</span>", Me.CurrentUser.Name, Me.lblValidUser.Text))
            If lblValidUser.Text = "Yes" Then
                output.Write("<p>")
                ctlUI.RenderControl(output)
                output.Write("</p>")
            End If
        End If
        Else
        lblMessage.RenderControl(output)
        End If

    End Sub

End Class

