Imports System
Imports System.Data
Imports System.ComponentModel
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Xml.Serialization
Imports System.Security
Imports System.Security.Permissions
Imports Microsoft.SharePoint
Imports Microsoft.SharePoint.Utilities
Imports Microsoft.SharePoint.WebControls
Imports Microsoft.SharePoint.WebPartPages
Imports Microsoft.SharePoint.WebPartPages.Communication
Imports VitalFactorsPortal.WebParts.VitalFactorsPortalWS

Public Class VitalFactors2UI
    Inherits System.Web.UI.UserControl

    Private currentSite As SPSite
    Protected WithEvents ddlDateSelector As System.Web.UI.WebControls.DropDownList
    Protected WithEvents btnShowGoals As System.Web.UI.WebControls.Button
    Protected WithEvents SmartScroller1 As StrengthControls.Scrolling.SmartScroller
    Protected WithEvents grdVitalFactors As FarPoint.Web.Spread.FpSpread

    Private currentWeb As SPWeb


#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub




    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Protected ctlUI As VitalFactors2UI
    Private _dataSource As DataSet
    Private sortFlag As Boolean = False

    Protected lblMessage As New Label

    Public Property DataSource() As DataSet
        Get
            Return _dataSource
        End Get
        Set(ByVal Value As DataSet)
            _dataSource = Value
        End Set
    End Property

    Private ReadOnly Property CurrentUser() As SPUser
        Get
            If currentWeb Is Nothing Or currentSite Is Nothing Then
                currentSite = SPControl.GetContextSite(Context)
                currentWeb = SPControl.GetContextWeb(Context)
            End If
            Return currentWeb.CurrentUser
        End Get
    End Property

    'config for web service URL
    Private _wsURL As String

    <Browsable(True), Category("Configuration"), _
    DefaultValue(""), _
    WebPartStorage(Storage.Shared), _
    FriendlyName("URL of Web Service"), _
    Description("Configurable URL for the Web Service that provides data for this web part")> _
    Public Property WS_URL() As String
        Get
            Return _wsURL
        End Get
        Set(ByVal Value As String)
            _wsURL = Value
        End Set
    End Property

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here

        Get_VitalFactors()


    End Sub

    Private Sub Get_VitalFactors()  'ByVal sMonth As String, ByVal sYear As String
        Dim iX As Integer, iRowCt As Integer, sAdd As String
        Dim sMonth As String, sYear As String

        Try
            Dim ws As New VitalFactorsPortalWS.VitalFactorsPortalWS
            Dim dsVitalFactors As DataSet
            Dim dsMonthAndYear As DataSet
            If Not IsPostBack Then
                dsMonthAndYear = ws.GetMonthAndYearForUser
                'Me.ddlDateSelector.Items.Add("YTD" & " - " & dsMonthAndYear.Tables(0).Rows(0).ItemArray(1))
                For iX = 0 To dsMonthAndYear.Tables(0).Rows.Count - 1
                    sAdd = dsMonthAndYear.Tables(0).Rows(iX).ItemArray(0) & " - " & dsMonthAndYear.Tables(0).Rows(iX).ItemArray(1)
                    Me.ddlDateSelector.Items.Add(sAdd)
                Next
                Me.ddlDateSelector.SelectedIndex = Me.ddlDateSelector.Items.Count - 1 '<--Select the last month.
            End If
            Dim sSelVal As String
            sSelVal = Me.ddlDateSelector.SelectedValue()
            sMonth = Mid(sSelVal, 1, 3)
            sYear = Right(sSelVal, 4)
            Select Case sMonth
                Case "YTD"
                    sMonth = "0"
                Case "JAN"
                    sMonth = "1"
                Case "FEB"
                    sMonth = "2"
                Case "MAR"
                    sMonth = "3"
                Case "APR"
                    sMonth = "4"
                Case "MAY"
                    sMonth = "5"
                Case "JUN"
                    sMonth = "6"
                Case "JUL"
                    sMonth = "7"
                Case "AUG"
                    sMonth = "8"
                Case "SEP"
                    sMonth = "9"
                Case "OCT"
                    sMonth = "10"
                Case "NOV"
                    sMonth = "11"
                Case "DEC"
                    sMonth = "12"
            End Select

            dsVitalFactors = ws.GetVitalFactorsForUser(sMonth, sYear) '<--Get vital factors for all branches.
            DataSource = dsVitalFactors

            'Create the branch list that the user has the rights to see here.
            Dim iTop As Integer, iRecCt As Integer, sBrhList As String
            Dim dsDivisions As DataSet
            dsDivisions = ws.GetDivisionsForUser(Me.CurrentUser.LoginName)
            iRecCt = dsDivisions.Tables("Divisions").Rows.Count
            If iRecCt > 0 Then
                For iX = 0 To iRecCt - 1
                    sBrhList = sBrhList & dsDivisions.Tables("Divisions").Rows(iX).ItemArray(0) & ","
                Next
                sBrhList = Mid(sBrhList, 1, Len(sBrhList) - 1)
            End If

            'Walk through the data table "VitalFactors" and mark the branches that the user is supposed to see.
            Dim sBrhNum As String
            For iX = 0 To dsVitalFactors.Tables("VitalFactors").Rows.Count - 1
                sBrhNum = dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0)
                If InStr(sBrhList, sBrhNum) > 0 Then dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0) = "*" & dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0)
            Next

            'Walk through the data table "VitalFactors" and remove the rows that the user is not supposed to see.
            Dim row As DataRow
            iX = 0
            Do
                iRowCt = dsVitalFactors.Tables("VitalFactors").Rows.Count
                If iX = iRowCt Then Exit Do
                row = dsVitalFactors.Tables("VitalFactors").Rows(iX)
                If Not row Is Nothing Then
                    sBrhNum = dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0)
                    If Left(sBrhNum, 1) <> "*" Then
                        dsVitalFactors.Tables("VitalFactors").Rows.Remove(row)
                    Else
                        iX = iX + 1
                    End If
                Else
                    Exit Do
                End If
            Loop

            'Walk through the data table "VitalFactors" and un-mark the branches that the user is supposed to see.
            For iX = 0 To dsVitalFactors.Tables("VitalFactors").Rows.Count - 1
                sBrhNum = dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0)
                If Left(sBrhNum, 1) = "*" Then dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0) = Mid(dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0), 2)
            Next

            iRowCt = dsVitalFactors.Tables("VitalFactors").Rows.Count
            If iRowCt <> 0 Then
                'Me.grdVitalFactors.ItemStyle.BackColor = Me.grdVitalFactors.ItemStyle.BackColor.Gainsboro
                'Me.grdVitalFactors.AlternatingItemStyle.BackColor = Me.grdVitalFactors.AlternatingItemStyle.BackColor.White
                'Bind the data.

                '''Format_Grid()

                Me.grdVitalFactors.DataSource = dsVitalFactors.Tables("VitalFactors")
                Me.grdVitalFactors.DataBind()

                'CalcPrecentages_ColorCells()
            Else
                Me.ddlDateSelector.Visible = False
                lblMessage.Text = "There is no vital factor data available for Division(s) " & sBrhList & "."
                Me.Controls.Add(lblMessage)
            End If
            Me.btnShowGoals.Visible = False

        Catch ex As Exception
            lblMessage.Text = "Error occured in Sub Get_VitalFactors - " & ex.Message
            Me.Controls.Add(lblMessage)
        End Try

    End Sub

    Private Sub Format_Grid()


        Me.grdVitalFactors.Width = System.Web.UI.WebControls.Unit.Pixel(700)
        'Me.grdVitalFactors.Height = System.Web.UI.WebControls.Unit.Pixel(300)

        Me.grdVitalFactors.RowHeader.Visible = False
        Me.grdVitalFactors.Sheets(0).Columns(0).Width = 50
        Me.grdVitalFactors.Sheets(0).Columns(0).HorizontalAlign = HorizontalAlign.Center

        Me.grdVitalFactors.Sheets(0).Columns(1).Width = 50
        Me.grdVitalFactors.Sheets(0).Columns(1).HorizontalAlign = HorizontalAlign.Center

    End Sub





    Private Sub btnShowGoals_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShowGoals.Click

        Get_VitalFactors()

    End Sub


End Class
