Imports System
Imports System.Data
Imports System.ComponentModel
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Xml.Serialization
Imports System.Security
Imports System.Security.Permissions
Imports Microsoft.SharePoint
Imports Microsoft.SharePoint.Utilities
Imports Microsoft.SharePoint.WebControls
Imports Microsoft.SharePoint.WebPartPages
Imports Microsoft.SharePoint.WebPartPages.Communication
Imports VitalFactorsPortal.WebParts.VitalFactorsPortalWS

Public Class VitalFactorsUI
    Inherits System.Web.UI.UserControl

    Private currentSite As SPSite
    Protected WithEvents ddlDateSelector As System.Web.UI.WebControls.DropDownList
    Protected WithEvents btnShowGoals As System.Web.UI.WebControls.Button
    Protected WithEvents SmartScroller1 As StrengthControls.Scrolling.SmartScroller
    Private currentWeb As SPWeb

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents grdVitalFactors As System.Web.UI.WebControls.DataGrid

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Protected ctlUI As VitalFactorsUI
    Private _dataSource As DataSet
    Private sortFlag As Boolean = False

    Protected lblMessage As New Label

    Public Property DataSource() As DataSet
        Get
            Return _dataSource
        End Get
        Set(ByVal Value As DataSet)
            _dataSource = Value
        End Set
    End Property

    Private ReadOnly Property CurrentUser() As SPUser
        Get
            If currentWeb Is Nothing Or currentSite Is Nothing Then
                currentSite = SPControl.GetContextSite(Context)
                currentWeb = SPControl.GetContextWeb(Context)
            End If
            Return currentWeb.CurrentUser
        End Get
    End Property

    'config for web service URL
    Private _wsURL As String

    <Browsable(True), Category("Configuration"), _
    DefaultValue(""), _
    WebPartStorage(Storage.Shared), _
    FriendlyName("URL of Web Service"), _
    Description("Configurable URL for the Web Service that provides data for this web part")> _
    Public Property WS_URL() As String
        Get
            Return _wsURL
        End Get
        Set(ByVal Value As String)
            _wsURL = Value
        End Set
    End Property

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
       
        Get_VitalFactors()
            

    End Sub

    Private Sub Get_VitalFactors()  'ByVal sMonth As String, ByVal sYear As String
        Dim iX As Integer, iRowCt As Integer, sAdd As String
        Dim sMonth As String, sYear As String

        Try
            Dim ws As New VitalFactorsPortalWS.VitalFactorsPortalWS
            Dim dsVitalFactors As DataSet
            Dim dsMonthAndYear As DataSet
            If Not IsPostBack Then
                dsMonthAndYear = ws.GetMonthAndYearForUser
                'Me.ddlDateSelector.Items.Add("YTD" & " - " & dsMonthAndYear.Tables(0).Rows(0).ItemArray(1))
                For iX = 0 To dsMonthAndYear.Tables(0).Rows.Count - 1
                    sAdd = dsMonthAndYear.Tables(0).Rows(iX).ItemArray(0) & " - " & dsMonthAndYear.Tables(0).Rows(iX).ItemArray(1)
                    Me.ddlDateSelector.Items.Add(sAdd)
                Next
                Me.ddlDateSelector.SelectedIndex = Me.ddlDateSelector.Items.Count - 1 '<--Select the last month.
            End If
            Dim sSelVal As String
            sSelVal = Me.ddlDateSelector.SelectedValue()
            sMonth = Mid(sSelVal, 1, 3)
            sYear = Right(sSelVal, 4)
            Select Case sMonth
                Case "YTD"
                    sMonth = "0"
                Case "JAN"
                    sMonth = "1"
                Case "FEB"
                    sMonth = "2"
                Case "MAR"
                    sMonth = "3"
                Case "APR"
                    sMonth = "4"
                Case "MAY"
                    sMonth = "5"
                Case "JUN"
                    sMonth = "6"
                Case "JUL"
                    sMonth = "7"
                Case "AUG"
                    sMonth = "8"
                Case "SEP"
                    sMonth = "9"
                Case "OCT"
                    sMonth = "10"
                Case "NOV"
                    sMonth = "11"
                Case "DEC"
                    sMonth = "12"
            End Select

            dsVitalFactors = ws.GetVitalFactorsForUser(sMonth, sYear) '<--Get vital factors for all branches.
            DataSource = dsVitalFactors

            'Create the branch list that the user has the rights to see here.
            Dim iTop As Integer, iRecCt As Integer, sBrhList As String
            Dim dsDivisions As DataSet
            dsDivisions = ws.GetDivisionsForUser(Me.CurrentUser.LoginName)
            iRecCt = dsDivisions.Tables("Divisions").Rows.Count
            If iRecCt > 0 Then
                For iX = 0 To iRecCt - 1
                    sBrhList = sBrhList & dsDivisions.Tables("Divisions").Rows(iX).ItemArray(0) & ","
                Next
                sBrhList = Mid(sBrhList, 1, Len(sBrhList) - 1)
            End If

            'Walk through the data table "VitalFactors" and mark the branches that the user is supposed to see.
            Dim sBrhNum As String
            For iX = 0 To dsVitalFactors.Tables("VitalFactors").Rows.Count - 1
                sBrhNum = dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0)
                If InStr(sBrhList, sBrhNum) > 0 Then dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0) = "*" & dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0)
            Next

            'Walk through the data table "VitalFactors" and remove the rows that the user is not supposed to see.
            Dim row As DataRow
            iX = 0
            Do
                iRowCt = dsVitalFactors.Tables("VitalFactors").Rows.Count
                If iX = iRowCt Then Exit Do
                row = dsVitalFactors.Tables("VitalFactors").Rows(iX)
                If Not row Is Nothing Then
                    sBrhNum = dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0)
                    If Left(sBrhNum, 1) <> "*" Then
                        dsVitalFactors.Tables("VitalFactors").Rows.Remove(row)
                    Else
                        iX = iX + 1
                    End If
                Else
                    Exit Do
                End If
            Loop

            'Walk through the data table "VitalFactors" and un-mark the branches that the user is supposed to see.
            For iX = 0 To dsVitalFactors.Tables("VitalFactors").Rows.Count - 1
                sBrhNum = dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0)
                If Left(sBrhNum, 1) = "*" Then dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0) = Mid(dsVitalFactors.Tables("VitalFactors").Rows(iX).Item(0), 2)
            Next

            iRowCt = dsVitalFactors.Tables("VitalFactors").Rows.Count
            If iRowCt <> 0 Then
                Me.grdVitalFactors.ItemStyle.BackColor = Me.grdVitalFactors.ItemStyle.BackColor.Gainsboro
                Me.grdVitalFactors.AlternatingItemStyle.BackColor = Me.grdVitalFactors.AlternatingItemStyle.BackColor.White
                'Bind the data.
                Me.grdVitalFactors.DataSource = dsVitalFactors.Tables("VitalFactors")
                Me.grdVitalFactors.DataBind()

                CalcPrecentages_ColorCells()
            Else
                Me.ddlDateSelector.Visible = False
                lblMessage.Text = "There is no vital factor data available for Division(s) " & sBrhList & "."
                Me.Controls.Add(lblMessage)
            End If
            Me.btnShowGoals.Visible = False

        Catch ex As Exception
            lblMessage.Text = "Error occured in Sub Get_VitalFactors - " & ex.Message
            Me.Controls.Add(lblMessage)
        End Try

    End Sub

    Private Sub CalcPrecentages_ColorCells()
        Dim iX As Integer, sTotRevGoal As String, sTotRevActual As String, dPercentage As Double
        Dim sTotGoal As String, sTotActual As String, dTotGoal As Double, dTotActual As Double

        Try
            If Me.grdVitalFactors.Items.Count = 0 Then Exit Sub
            'Calc the goals to actual percentage.
            iX = 0
            Do
                'Calc the total revenue goals to actual percentage and change the cell backcolor appropriately.
                sTotRevGoal = Me.grdVitalFactors.Items(iX).Cells(3).Text()
                sTotRevActual = Me.grdVitalFactors.Items(iX + 1).Cells(3).Text()
                If CDbl(sTotRevActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(3).Text() = "N/A"
                Else
                    If CDbl(sTotRevGoal) = 0 Then sTotRevGoal = 1
                    dPercentage = (sTotRevActual / sTotRevGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(3).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(3).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(3).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the total rental revenue goals to actual percentage and change the cell backcolor appropriately.
                sTotRevGoal = Me.grdVitalFactors.Items(iX).Cells(4).Text()
                sTotRevActual = Me.grdVitalFactors.Items(iX + 1).Cells(4).Text()
                If CDbl(sTotRevActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(4).Text() = "N/A"
                Else
                    If CDbl(sTotRevGoal) = 0 Then sTotRevGoal = 1
                    dPercentage = (sTotRevActual / sTotRevGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(4).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(4).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(4).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the filtration revenue goals to actual percentage and change the cell backcolor appropriately.
                sTotRevGoal = Me.grdVitalFactors.Items(iX).Cells(5).Text()
                sTotRevActual = Me.grdVitalFactors.Items(iX + 1).Cells(5).Text()
                If CDbl(sTotRevActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(5).Text() = "N/A"
                Else
                    If CDbl(sTotRevGoal) = 0 Then sTotRevGoal = 1
                    dPercentage = (sTotRevActual / sTotRevGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(5).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(5).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(5).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the fuel surcharge revenue goals to actual percentage and change the cell backcolor appropriately.
                sTotRevGoal = Me.grdVitalFactors.Items(iX).Cells(6).Text()
                sTotRevActual = Me.grdVitalFactors.Items(iX + 1).Cells(6).Text()
                If CDbl(sTotRevActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(6).Text() = "N/A"
                Else
                    If CDbl(sTotRevGoal) = 0 Then sTotRevGoal = 1
                    dPercentage = (sTotRevActual / sTotRevGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(6).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(6).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(6).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the active customer goal to actual percentage and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(7).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(7).Text()
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(7).Text() = "N/A"
                Else
                    If CDbl(sTotGoal) = 0 Then sTotGoal = 1
                    dPercentage = (sTotActual / sTotGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(7).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(7).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(7).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the call mileage calls goal to actual percentage and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(8).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(8).Text()
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(8).Text() = "N/A"
                Else
                    If CDbl(sTotGoal) = 0 Then sTotGoal = 1
                    dPercentage = (sTotActual / sTotGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(8).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(8).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(8).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the tow & show goal to actual percentage and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(9).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(9).Text()
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(9).Text() = "N/A"
                Else
                    If CDbl(sTotGoal) = 0 Then sTotGoal = 1
                    dPercentage = (sTotActual / sTotGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(9).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(9).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(9).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the brown bag goal to actual percentage and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(10).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(10).Text()
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(10).Text() = "N/A"
                Else
                    If CDbl(sTotGoal) = 0 Then sTotGoal = 1
                    dPercentage = (sTotActual / sTotGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(10).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(10).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(10).BackColor = System.Drawing.Color.Tomato
                End If


                'Calc the cost recovery revenue goal to actual percentage and change the cell backcolor appropriately.
                sTotRevGoal = Me.grdVitalFactors.Items(iX).Cells(11).Text()
                sTotRevActual = Me.grdVitalFactors.Items(iX + 1).Cells(11).Text()
                sTotRevGoal = Left(sTotRevGoal, Len(sTotRevGoal) - 1) '<--Remove the % sign.
                sTotRevActual = Left(sTotRevActual, Len(sTotRevActual) - 1) '<--Remove the % sign.
                If CDbl(sTotRevActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(11).Text() = "N/A"
                Else
                    If CDbl(sTotRevGoal) = 0 Then sTotRevGoal = 1
                    dPercentage = (CDbl(sTotRevActual) / CDbl(sTotRevGoal)) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(11).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(11).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(11).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the damage billing revenue goal to actual percentage and change the cell backcolor appropriately.
                sTotRevGoal = Me.grdVitalFactors.Items(iX).Cells(12).Text()
                sTotRevActual = Me.grdVitalFactors.Items(iX + 1).Cells(12).Text()
                If CDbl(sTotRevActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(12).Text() = "N/A"
                Else
                    If CDbl(sTotRevGoal) = 0 Then sTotRevGoal = 1
                    dPercentage = (CDbl(sTotRevActual) / CDbl(sTotRevGoal)) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(12).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(12).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(12).BackColor = System.Drawing.Color.Tomato
                End If


                'Calc the pump touch goal to actual percentage and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(13).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(13).Text()
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(13).Text() = "N/A"
                Else
                    If CDbl(sTotGoal) = 0 Then sTotGoal = 1
                    dPercentage = (sTotActual / sTotGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(13).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(13).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(13).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the labor hauling revenue goal to actual percentage and change the cell backcolor appropriately.
                sTotRevGoal = Me.grdVitalFactors.Items(iX).Cells(14).Text()
                sTotRevActual = Me.grdVitalFactors.Items(iX + 1).Cells(14).Text()
                If CDbl(sTotRevActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(14).Text() = "N/A"
                Else
                    If CDbl(sTotRevGoal) = 0 Then sTotRevGoal = 1
                    dPercentage = (sTotRevActual / sTotRevGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(14).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(14).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(14).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the pump & pipe revenue goal to actual percentage and change the cell backcolor appropriately.
                sTotRevGoal = Me.grdVitalFactors.Items(iX).Cells(15).Text()
                sTotRevActual = Me.grdVitalFactors.Items(iX + 1).Cells(15).Text()
                If CDbl(sTotRevActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(15).Text() = "N/A"
                Else
                    If CDbl(sTotRevGoal) = 0 Then sTotRevGoal = 1
                    dPercentage = (sTotRevActual / sTotRevGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(15).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(15).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(15).BackColor = System.Drawing.Color.Tomato
                End If

                'Calc the net profit revenue goal to actual percentage and change the cell backcolor appropriately.
                sTotRevGoal = Me.grdVitalFactors.Items(iX).Cells(16).Text()
                sTotRevActual = Me.grdVitalFactors.Items(iX + 1).Cells(16).Text()
                If CDbl(sTotRevActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(16).Text() = "N/A"
                Else
                    If CDbl(sTotRevGoal) = 0 Then sTotRevGoal = 1
                    dPercentage = (sTotRevActual / sTotRevGoal) * 100
                    If dPercentage >= 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(16).BackColor = System.Drawing.Color.LightGreen
                    If dPercentage >= 70 And dPercentage < 90 Then Me.grdVitalFactors.Items(iX + 1).Cells(16).BackColor = System.Drawing.Color.Khaki
                    If dPercentage < 70 Then Me.grdVitalFactors.Items(iX + 1).Cells(16).BackColor = System.Drawing.Color.Tomato
                End If

                'Compare the recordables goal to actual and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(17).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(17).Text()
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(17).Text() = "N/A"
                Else
                    If CDbl(sTotActual) <= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(17).BackColor = System.Drawing.Color.LightGreen
                    If CDbl(sTotActual) > CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(17).BackColor = System.Drawing.Color.Tomato
                End If


                'Compare the loss costs actual to goal and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(18).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(18).Text()
                sTotGoal = Left(sTotGoal, Len(sTotGoal) - 1) '<--Remove the % sign.
                sTotActual = Left(sTotActual, Len(sTotActual) - 1) '<--Remove the % sign.
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(18).Text() = "N/A"
                Else
                    If CDbl(sTotActual) <= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(18).BackColor = System.Drawing.Color.LightGreen
                    If CDbl(sTotActual) > CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(18).BackColor = System.Drawing.Color.Tomato
                End If


                'Compare the DOT service hrs actual to goal and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(19).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(19).Text()
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(19).Text() = "N/A"
                Else
                    If CDbl(sTotActual) <= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(19).BackColor = System.Drawing.Color.LightGreen
                    If CDbl(sTotActual) > CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(19).BackColor = System.Drawing.Color.Tomato
                End If

                'Compare the Credit Invoices < 3% actual to goal and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(20).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(20).Text()
                sTotGoal = Left(sTotGoal, Len(sTotGoal) - 1) '<--Remove the % sign.
                sTotActual = Left(sTotActual, Len(sTotActual) - 1) '<--Remove the % sign.
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(20).Text() = "N/A"
                Else
                    If CDbl(sTotActual) <= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(20).BackColor = System.Drawing.Color.LightGreen
                    If CDbl(sTotActual) > CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(20).BackColor = System.Drawing.Color.Tomato
                End If

                'Compare the On Time Billing < 4 Days actual to goal and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(21).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(21).Text()
                sTotGoal = Left(sTotGoal, Len(sTotGoal) - 1) '<--Remove the % sign.
                sTotActual = Left(sTotActual, Len(sTotActual) - 1) '<--Remove the % sign.
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(21).Text() = "N/A"
                Else
                    If CDbl(sTotActual) < CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(21).BackColor = System.Drawing.Color.Tomato
                    If CDbl(sTotActual) >= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(21).BackColor = System.Drawing.Color.LightGreen
                End If

                'Compare the Past Due Contracts actual to goal and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(22).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(22).Text()
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(22).Text() = "N/A"
                Else
                    If CDbl(sTotActual) <= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(22).BackColor = System.Drawing.Color.LightGreen
                    If CDbl(sTotActual) > CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(22).BackColor = System.Drawing.Color.Tomato
                End If

                'Compare the AR Over 90 actual to goal and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(23).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(23).Text()
                sTotGoal = Left(sTotGoal, Len(sTotGoal) - 1) '<--Remove the % sign.
                sTotActual = Left(sTotActual, Len(sTotActual) - 1) '<--Remove the % sign.
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(23).Text() = "N/A"
                Else
                    If CDbl(sTotActual) <= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(23).BackColor = System.Drawing.Color.LightGreen
                    If CDbl(sTotActual) > CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(23).BackColor = System.Drawing.Color.Tomato
                End If

                'Compare the DSO Under 37 actual to goal and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(24).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(24).Text()
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(24).Text() = "N/A"
                Else
                    If CDbl(sTotActual) < CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(24).BackColor = System.Drawing.Color.LightGreen
                    If CDbl(sTotActual) >= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(24).BackColor = System.Drawing.Color.Tomato
                End If

                'Compare the Finance Charge Collection % actual to goal and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(25).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(25).Text()
                sTotGoal = Left(sTotGoal, Len(sTotGoal) - 1) '<--Remove the % sign.
                sTotActual = Left(sTotActual, Len(sTotActual) - 1) '<--Remove the % sign.
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(25).Text() = "N/A"
                Else
                    If CDbl(sTotActual) < CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(25).BackColor = System.Drawing.Color.Tomato
                    If CDbl(sTotActual) >= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(25).BackColor = System.Drawing.Color.LightGreen
                End If

                'Compare the Employee Turnover % actual to goal and change the cell backcolor appropriately.
                sTotGoal = Me.grdVitalFactors.Items(iX).Cells(26).Text()
                sTotActual = Me.grdVitalFactors.Items(iX + 1).Cells(26).Text()
                sTotGoal = Left(sTotGoal, Len(sTotGoal) - 1) '<--Remove the % sign.
                sTotActual = Left(sTotActual, Len(sTotActual) - 1) '<--Remove the % sign.
                If CDbl(sTotActual) = -999 Then
                    Me.grdVitalFactors.Items(iX + 1).Cells(26).Text() = "N/A"
                Else
                    If CDbl(sTotActual) <= CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(26).BackColor = System.Drawing.Color.LightGreen
                    If CDbl(sTotActual) > CDbl(sTotGoal) Then Me.grdVitalFactors.Items(iX + 1).Cells(26).BackColor = System.Drawing.Color.Tomato
                End If

                iX = iX + 2
                'iX = iX / 0 '<--Create and error.
            Loop Until iX >= Me.grdVitalFactors.Items.Count

        Catch ex As Exception
            lblMessage.Text = "Error occured in Sub CalcPrecentages_ColorCells - " & ex.Message
            Me.Controls.Add(lblMessage)
        End Try

    End Sub

    Protected Function GetFaces(ByVal Value As String) As String

        Select Case Value
            Case "3"
                Return "/_layouts/images/FACE03.JPG"
            Case "2"
                Return "/_layouts/images/FACE02.JPG"
            Case "1"
                Return "/_layouts/images/FACE01.JPG"
            Case "0"
                Return "/_layouts/images/BLANK.ICO"
            Case "-1"
                Return "/_layouts/images/NA.JPG"
        End Select

    End Function

    Private Sub RemoveGoalRows(ByVal dg As DataGrid, ByVal TableName As String)
        Dim iRowCt As Integer, iX As Integer, sTemp As String, sText As String

        Try
            'Walk through the data table "VitalFactors" and remove the "Goal" rows.
            Dim row As DataRow
            iX = 0
            Do
                iRowCt = _dataSource.Tables(TableName).Rows.Count
                If iX = iRowCt Then Exit Do
                row = _dataSource.Tables(TableName).Rows(iX)
                If Not row Is Nothing Then
                    sText = _dataSource.Tables(TableName).Rows(iX).Item(1)
                    If sText = "Goal" Then
                        _dataSource.Tables(TableName).Rows.Remove(row)
                    Else
                        iX = iX + 1
                    End If
                Else
                    Exit Do
                End If
            Loop

            Me.grdVitalFactors.ItemStyle.BackColor = Me.grdVitalFactors.ItemStyle.BackColor.White
            Me.grdVitalFactors.AlternatingItemStyle.BackColor = Me.grdVitalFactors.AlternatingItemStyle.BackColor.White
            'ReBindData
            Me.grdVitalFactors.DataSource = _dataSource.Tables(TableName)
            Me.grdVitalFactors.DataBind()

        Catch ex As Exception
            lblMessage.Text = "Error occured in Sub RemoveGoalRows - " & ex.Message
            Me.Controls.Add(lblMessage)
        End Try

    End Sub

    Private Sub grdVitalFactors_SortCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridSortCommandEventArgs) Handles grdVitalFactors.SortCommand

        RemoveGoalRows(grdVitalFactors, "VitalFactors")
        DoSort(grdVitalFactors, e.SortExpression, "VitalFactors")
        LookForNeg999()
        Me.btnShowGoals.Visible = True

    End Sub

    Private Sub DoSort(ByVal dg As DataGrid, ByVal sSort As String, ByVal TableName As String)
        Dim dv As DataView, sSortEx As String, sDirection As String

        Call HandleSort(sSort)

        sSortEx = ViewState("SortExpression").ToString
        sDirection = ViewState("SortDirection").ToString
        dv = _dataSource.Tables(TableName).DefaultView
        dv.Sort = ViewState("SortExpression").ToString & " " & ViewState("SortDirection").ToString
        dg.DataSource = dv
        dg.DataBind()
        Me.sortFlag = True


    End Sub

    Public Sub HandleSort(ByVal SortExpression As String)
        Dim sDirection As String, sSE As String

        If SortExpression = String.Empty Then
            SortExpression = "Division"
            sDirection = "ASC"
        End If

        sSE = CStr(ViewState("SortExpression"))

        If SortExpression = sSE Then
            If CStr(ViewState("SortDirection")) = "ASC" Then
                sDirection = "DESC"
            Else
                sDirection = "ASC"
            End If
        Else
            sDirection = "DESC"
        End If

        ViewState("SortExpression") = SortExpression
        ViewState("SortDirection") = sDirection

    End Sub

    Private Sub LookForNeg999()
        Dim iX As Integer, sTemp As String

        If Me.grdVitalFactors.Items.Count = 0 Then Exit Sub

        iX = 0
        Do
            sTemp = Me.grdVitalFactors.Items(iX).Cells(3).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(3).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(4).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(4).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(5).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(5).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(6).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(6).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(7).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(7).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(8).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(8).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(9).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(9).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(10).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(10).Text() = "N/A"
            End If

            sTemp = Me.grdVitalFactors.Items(iX).Cells(11).Text()
            sTemp = Left(sTemp, Len(sTemp) - 1) '<--Remove the % sign.
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(11).Text() = "N/A"
            End If

            sTemp = Me.grdVitalFactors.Items(iX).Cells(12).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(12).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(13).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(13).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(14).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(14).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(15).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(15).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(16).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(16).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(17).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(17).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(18).Text()
            sTemp = Left(sTemp, Len(sTemp) - 1) '<--Remove the % sign.
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(18).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(19).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(19).Text() = "N/A"
            End If

            sTemp = Me.grdVitalFactors.Items(iX).Cells(20).Text()
            sTemp = Left(sTemp, Len(sTemp) - 1) '<--Remove the % sign.
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(20).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(21).Text()
            sTemp = Left(sTemp, Len(sTemp) - 1) '<--Remove the % sign.
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(21).Text() = "N/A"
            End If

            sTemp = Me.grdVitalFactors.Items(iX).Cells(22).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(22).Text() = "N/A"
            End If

            sTemp = Me.grdVitalFactors.Items(iX).Cells(23).Text()
            sTemp = Left(sTemp, Len(sTemp) - 1) '<--Remove the % sign.
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(23).Text() = "N/A"
            End If

            sTemp = Me.grdVitalFactors.Items(iX).Cells(24).Text()
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(24).Text() = "N/A"
            End If

            sTemp = Me.grdVitalFactors.Items(iX).Cells(25).Text()
            sTemp = Left(sTemp, Len(sTemp) - 1) '<--Remove the % sign.
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(25).Text() = "N/A"
            End If
            sTemp = Me.grdVitalFactors.Items(iX).Cells(26).Text()
            sTemp = Left(sTemp, Len(sTemp) - 1) '<--Remove the % sign.
            If CDbl(sTemp) = -999 Then
                Me.grdVitalFactors.Items(iX).Cells(26).Text() = "N/A"
            End If


            iX = iX + 1
        Loop Until iX >= Me.grdVitalFactors.Items.Count

    End Sub

    Private Sub grdVitalFactors_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles grdVitalFactors.ItemDataBound
        Dim sTemp As String
        Try
            'sTemp = e.Item.Cells(20).Text
            'If (e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem) Then
            '    If InStr(sTemp, "%") > 0 Then
            '        sTemp = Left(sTemp, Len(sTemp) - 1) '<--Remove the % sign.
            '        If CDbl(sTemp) = -1 Then
            '            e.Item.Cells(20).Text = "No Value"
            '        End If
            '    Else
            '        If CDbl(sTemp) = -999 Then
            '            e.Item.Cells(20).Text = "N/A"
            '        End If
            '    End If

            'If e.Item.Cells(3).Text < 400000 Then
            'e.Item.Cells(3).BackColor = System.Drawing.Color.FromName("#ffccff")
            'If e.Item.DataItem("Division") = "025" Then
            '    e.Item.Cells(1).BackColor = System.Drawing.Color.DeepPink()
            'End If
            'End If
            'End If

        Catch ex As Exception
            lblMessage.Text = ex.Message
            Me.Controls.Add(lblMessage)
        End Try

    End Sub

    Private Sub btnShowGoals_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShowGoals.Click

        Get_VitalFactors()

    End Sub

End Class
